<template>
  <Line id="chart-country-and-catalogue" :data="preparedData" :options="options" />
</template>

<script>
import { Line } from 'vue-chartjs';
import {customLegend} from "../../utils/legendPlugin";
import {chartColors} from "../../utils/chartColors";

import {
  Chart as ChartJS,
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  Filler
} from 'chart.js';

ChartJS.register(
  CategoryScale,
  LinearScale,
  PointElement,
  LineElement,
  Title,
  Tooltip,
  Filler,
  customLegend
);

export default {
  name : "LineChartCountryAndCatalogue",
  components: { Line },
  props: {
    chartdata: {
      type: [Array, Object],
      default: null
    },
    chartlabels: {
      type: Array,
      required: true
    },
    date: {
      type: Array,
      required: true
    }
  },
  data () {
    return {
      preparedData: {
        labels: this.date,
        datasets: chartColors.slice(0, this.chartdata.length).map((color, index) => (
          {
            label: this.chartlabels[index].name,
            data: this.chartdata[index],
            borderColor: color,
            backgroundColor: color,
            fill: false,
            tension: 0.2
          }
        ))
      },
      plugins: [],
      options: {
        plugins: {
          legend: false,
          customLegend: {
            elementId: "line-chart-catalogue-js-legend",
            hideAbove: 9
          }
        },
        responsive: true
        // scales: {
        //   yAxes: [{
        //     ticks: {
        //       beginAtZero: true,
        //       callback: function(value) {
        //         return value.toLocaleString('fi');
        //       }
        //     },
        //     gridLines: {
        //       display: true
        //     }
        //   }],
        //   xAxes: [ {
        //     gridLines: {
        //       display: false
        //     }
        //   }]
        // },
        // tooltip: {
        //   callbacks: {
        //     label: function(tooltipItem, data) {
        //       var label = data.datasets[tooltipItem.datasetIndex].label || '';
        //       if (label) label += ': ';
        //       label += (Math.round(tooltipItem.yLabel * 100) / 100).toLocaleString('fi');
        //       return label;
        //     }
        //   }
        },
      }
    }
  }

</script>
